# Check for bash
[ -z "$BASH_VERSION" ] && return

__contains_word () {
	local word=$1
	shift
	for w in $*
	do
		[[ $w = $word ]] && return 0
	done
	return 1
}

__get_opts_help () { echo '' ; }
__get_opts_api_version () { echo '' ; }
__get_opts_sys_info () { echo '' ; }
__get_opts_list_pkg () { echo '' ; }
__get_opts_test_running_installation() { echo '' ; }
__get_opts_db_server_type () { echo 'postgresql netezza solid' ; }
__get_opts_install () { echo '--nodeid= --datarelease= --data-type= --housing= --repo-sw-url= --use-api-version= --target-arch= --target-board-name= --db-server= --without-db-data --without-load-db-data' ; }
__get_opts_install_only () { echo '--repo-sw-url= --target-arch= --target-board-name= --db-server=' ; }
__get_opts_install_on_working () { echo '--nodeid= --datarelease= --data-type= --housing= --repo-sw-url= --use-api-version= --target-arch= --target-board-name= --db-server= --without-db-data --without-load-db-data' ; }
__get_opts_set_active_release () { echo '--product=' ; }
__get_opts_get_solid_id () { echo '' ; }
__get_opts_show_db_status () { echo '' ; }
__get_opts_activate_replication () { echo '--use-api-version= --nodeid= --dbrelease= --datarelease= --master-node-name= --replica-node-name= --master-connection-string= --master-username= --master-password= --db-server=' ; }
__get_opts_deactivate_replication () { echo '--use-api-version= --nodeid= --dbrelease= --datarelease= --master-node-name= --replica-node-name= --master-connection-string= --master-username= --master-password= --db-server=' ; }
__get_opts_refresh () { echo '--use-api-version= --nodeid= --dbrelease= --datarelease= --catalog-name= --db-server=' ; }
__get_opts_upgrade () { echo '--use-api-version= --nodeid= --dbrelease= --datarelease= --master-node-name= --replica-node-name= --master-connection-string= --master-username= --master-password= --db-server=' ; }
__get_opts_install_data_from_disc () { echo '--product= --db-server=' ; }


_element_admin ()
{
	local command=${COMP_WORDS[1]}
	local cur=${COMP_WORDS[COMP_CWORD]} prev=${COMP_WORDS[COMP_CWORD-1]}
	local verb comps
	local -A COMMANDS=(
		[HELP]='--help'
		[GETAPIVERSION]='--get-api-version'
		[SYSINFO]='--sys-info'
		[LISTPKG]='--list-pkg'
		[INSTALL]='--install'
		[TESTRUNNINGINSTALLATION]='--test-running-installation'
		[INSTALLPLARFORM]='--install-platform-only'
		[INSTALLONWORKING]='--install-on-working'
		[SETACTIVERELEASE]='--set-active-release'
		[GETSOLIDID]='--get-solid-uid'
		[SHOWDBSTATUS]='--show-db-status'
		[ACTIVATEREPLICATION]='--activate-replication'
		[DEACTIVATEREPLICATION]='--deactivate-replication'
		[REFRESH]='--refresh'
		[UPGRADE]='--upgrade'
		[INSTALLDATAFROMDISC]='--install-data-from-disc'
	)

	if [ "$verb" = "" -a "$prev" = "element-admin.sh" ]
	then
		comps="${COMMANDS[*]}"
	elif __contains_word "$command" ${COMMANDS[HELP]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_help ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[GETAPIVERSION]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_api_version ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[SYSINFO]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_sys_info ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[LISTPKG]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_list_pkg ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[TESTRUNNINGINSTALLATION]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_test_running_installation ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[INSTALL]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_install ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[INSTALLPLARFORM]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_install_only ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[INSTALLONWORKING]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_install_on_working ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[SETACTIVERELEASE]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_set_active_release ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[GETSOLIDID]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_get_solid_id ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[SHOWDBSTATUS]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_show_db_status ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[ACTIVATEREPLICATION]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_deactivate_replication ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[DEACTIVATEREPLICATION]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_activate_replication ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[REFRESH]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_refresh ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[UPGRADE]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_upgrade ) " -- "$cur") )
		return 0
	elif __contains_word "$command" ${COMMANDS[INSTALLDATAFROMDISC]}
	then
		COMPREPLY=( $(compgen -W "$( __get_opts_install_data_from_disc ) " -- "$cur") )
		return 0
	fi
	COMPREPLY=( $(compgen -W "$comps" -- "$cur") )
	return 0
}

complete -F _element_admin element-admin.sh

